dss = {};

dss.ajaxSyncRequest = function(surl, params) {
    var xmlHttp = null;
    params.a = Math.random();

    var paramString = "?"

    for ( var key in params) {
        paramString += key + "=" + encodeURIComponent(params[key]) + "&";
    }

    if (typeof XMLHttpRequest != 'undefined') {
        xmlHttp = new XMLHttpRequest();
    }
    if (!xmlHttp) {
        try {
            xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
        } catch (e) {
            try {
                xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
            } catch (e) {
                xmlHttp = null;
            }
        }
    }
    if (xmlHttp) {
        xmlHttp.open('GET', surl + paramString, false);
        xmlHttp.send(null);
        return xmlHttp.responseText;
    }
}

dss.ajaxAssyncRequestWithoutAnswer = function(surl, params, callback) {
    var xmlHttp = null;
    params.a = Math.random();

    var paramString = "?"

    for ( var key in params) {
        paramString += key + "=" + encodeURIComponent(params[key]) + "&";
    }

    if (typeof XMLHttpRequest != 'undefined') {
        xmlHttp = new XMLHttpRequest();
    }
    if (!xmlHttp) {
        try {
            xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
        } catch (e) {
            try {
                xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
            } catch (e) {
                xmlHttp = null;
            }
        }
    }
    if (xmlHttp) {
        if (callback != null)
            xmlHttp.onreadystatechange = function() {
                if (xmlHttp.readyState == 4)
                    callback(xmlHttp.responseText);
            };
        xmlHttp.open('GET', surl + paramString, true);
        xmlHttp.send(null);
    }
}

dss.raiseEvent = function(name, params) {
    var sURL = '/json/event/raise';
    var paramString = "";
    for ( var key in params) {
        paramString += key + "=" + encodeURIComponent(params[key]) + ";";
    }
    dss.ajaxAssyncRequestWithoutAnswer(sURL, {
        'name' : name,
        'parameter' : paramString.substr(0, paramString.length - 1)
    });
}

dss.staticDataModel = {};
dss.staticDataModel.baseImagePath = "/framework/images/";
dss.staticDataModel.sQueryStringDevices = "/apartment/zones/zone0/devices/*(*)/*(*)/*(*)";
dss.staticDataModel.sQueryStringStructure = '/apartment/zones/*(ZoneID,name)/groups/*(group,name)/scenes/*(scene,name)';
dss.staticDataModel.sQueryStringHLE = '/usr/events/*(name,id)';
dss.staticDataModel.sQueryStringUSR = '/usr/*/*(name,id,value)/*(*)';
dss.staticDataModel.nameCache = null;
dss.staticDataModel.deviceCache = null;
dss.staticDataModel.HLECache = null;
dss.staticDataModel.StateCache = null;
dss.staticDataModel.activeLanguage="de_DE";
dss.staticDataModel.deviceWithSensorsCache = null;

dss.staticDataModel.getHLENameFromId = function(id) {
    for ( var iIndex = 0; iIndex < dss.staticDataModel.HLECache.length; iIndex++) {
        if (dss.staticDataModel.HLECache[iIndex].id == id)
            return dss.staticDataModel.HLECache[iIndex].name;
    }
    return id;
}

dss.staticDataModel.initCaches = function() {
    dss.staticDataModel.initNameCache();
    dss.staticDataModel.initDeviceCache();
    dss.staticDataModel.initHLECache();
}

dss.staticDataModel.initNameCache = function() {
    var sResult = dss.ajaxSyncRequest('/json/property/query', {
        'query' : dss.staticDataModel.sQueryStringStructure
    });
    var resultObj = Ext.JSON.decode(sResult);
    if (resultObj.ok) {
        if (resultObj.result.zones != null) {
            dss.staticDataModel.nameCache = resultObj.result.zones;
        }
    }
}
dss.staticDataModel.initDeviceCache = function() {
    var sResult = dss.ajaxSyncRequest('/json/property/query', {
        'query' : dss.staticDataModel.sQueryStringDevices
    });
    var resultObj = Ext.JSON.decode(sResult);
    if (resultObj.ok) {
        dss.staticDataModel.deviceCache = [];
        dss.staticDataModel.deviceWithSensorsCache = [];
        if (resultObj.result.devices!=null) {
            for ( var iIndex = 0; iIndex < resultObj.result.devices.length; iIndex++) {
                var oDevObject = resultObj.result.devices[iIndex];
                var newObject = {
                    dSID : oDevObject.dSID,
                    name : oDevObject.name,
                    present : oDevObject.present,
                    functionID : oDevObject.functionID,
                    productID : oDevObject.productID,
                    outputMode : oDevObject.outputMode,
                    ZoneID : oDevObject.ZoneID,
                    DSMeterDSID : oDevObject.DSMeterDSID
                };
                var subObject = oDevObject[oDevObject.dSID];
                for ( var jIndex = 0; jIndex < subObject.length; jIndex++) {
                    if (subObject[jIndex].sensorEvents != null) {
                        newObject.sensorEvents = [];
                        for ( var sKey in subObject[jIndex]) {
                            if (sKey != 'sensorEvents')
                                newObject.sensorEvents.push({name:subObject[jIndex][sKey],id:sKey});
                        }
                    }
                    if (subObject[jIndex].button != null) {
                        if (subObject[jIndex].id != null)
                            newObject.tasterMode = subObject[jIndex].id;
                        if (subObject[jIndex].groupMembership != null)
                            newObject.buttonGroupMembership = subObject[jIndex].groupMembership;
                        if (subObject[jIndex].activeGroup != null)
                            newObject.buttonActiveGroup = subObject[jIndex].activeGroup;
                        if (subObject[jIndex].setsLocalPriority != null)
                            newObject.buttonSetsLocalPriority = subObject[jIndex].setsLocalPriority;
                        if (subObject[jIndex].inputMode != null)
                            newObject.buttonType = subObject[jIndex].inputMode;
                    }
                    if (subObject[jIndex].groups != null) {
                        if (subObject[jIndex].groups != null) {
                            for ( var kIndex = 0; kIndex < subObject[jIndex].groups.length; kIndex++)
                                if (subObject[jIndex].groups[kIndex] != 8) // standardgruppe
																			// fr
																			// ausfhrung
																			// ist
																			// niemals
																			// gruppe
																			// 8
                                    newObject.GroupID = subObject[jIndex].groups[kIndex].id;
                        }
                    }
                }
                if (newObject.name == "")
                    newObject.name = "(" + newObject.dSID.substring(16) + ")";
                newObject.icon = dss.staticDataModel.getImageForDevice(newObject);
                dss.staticDataModel.deviceCache.push(newObject);
                if (newObject.sensorEvents != null)
                    if (newObject.sensorEvents.length > 0)
                        dss.staticDataModel.deviceWithSensorsCache.push(newObject);
            }
        }
    }
    for ( var iIndex = 0; iIndex < dss.staticDataModel.nameCache.length; iIndex++) {
        var oZone = dss.staticDataModel.nameCache[iIndex];
        if (oZone.name == "") {
            if (oZone.ZoneID == 0)
                oZone.name = _('All rooms');
            else
                oZone.name = Ext.String.format2(_("Room ID {zone}"),{zone:oZone.ZoneID});
        }
        for ( var jIndex = 0; jIndex < oZone.groups.length; jIndex++) {
            var oGroup = oZone.groups[jIndex];
            oGroup.icon = dss.staticDataModel.getImagePathForGroup(oZone.ZoneID, oGroup.group);
            oGroup.name = dss.staticDataModel.getNameForGroup(oZone.ZoneID, oGroup.group);
            oGroup.reachable = false;
            if (oGroup.group == 0)
                oGroup.reachable = true;
            for ( var iDeviceIndex = 0; iDeviceIndex < dss.staticDataModel.deviceCache.length; iDeviceIndex++)
                if ((dss.staticDataModel.deviceCache[iDeviceIndex].ZoneID == oZone.ZoneID) || (oZone.ZoneID == 0))
                    if (dss.staticDataModel.deviceCache[iDeviceIndex].buttonActiveGroup == oGroup.group)
                        oGroup.reachable = true;
        }
    }
}

dss.staticDataModel.initHLECache = function() {
    dss.staticDataModel.HLECache = [];
    dss.staticDataModel.StateCache = [];
    var sResult = dss.ajaxSyncRequest('/json/property/query', {
        'query' : dss.staticDataModel.sQueryStringUSR
    });
    var resultObj = Ext.JSON.decode(sResult);
    if (resultObj.ok) {
        if (resultObj.result.events != null) {
            for (var iIndex=0;iIndex<resultObj.result.events.length;iIndex++) {
                var oObject={   name: resultObj.result.events[iIndex].name,
                                id: resultObj.result.events[iIndex].id};
                dss.staticDataModel.HLECache.push(oObject);
            }
        }
        if (resultObj.result.states != null) {
            for (var iIndex=0;iIndex<resultObj.result.states.length;iIndex++) {
                var oObjectState={  name: resultObj.result.states[iIndex].name,
                                    value: resultObj.result.states[iIndex].value,
                                    valuerange:[]};
                for (var sKey in resultObj.result.states[iIndex]) {
                    if (sKey!='name')
                        if (sKey!='value') {
                            for (var jIndex=0;jIndex<resultObj.result.states[iIndex][sKey].length;jIndex++)
                                for (var sSubKey in resultObj.result.states[iIndex][sKey][jIndex]) {
                                    var oValue={name:sSubKey,value: resultObj.result.states[iIndex][sKey][jIndex][sSubKey]};
                                    oObjectState.valuerange.push(oValue);
                                }
                        }
                } 
                if (oObjectState.valuerange.length==0) { 
                    oObjectState.valuerange.push({name:_('active'),value:true});
                    oObjectState.valuerange.push({name:_('inactive'),value:false});
                }
                dss.staticDataModel.StateCache.push(oObjectState);
            }
            
        }        
    }
}

dss.staticDataModel.getHLE = function() {
    if (dss.staticDataModel.HLECache == null)
        dss.staticDataModel.initHLECache();
    return dss.staticDataModel.HLECache;
}

dss.staticDataModel.getStates = function() {
    if (dss.staticDataModel.StateCache == null)
        dss.staticDataModel.initHLECache();
    
    var oResult = [];
    for ( var iIndex = 0; iIndex < dss.staticDataModel.StateCache.length; iIndex++) {
        var valuerange=[];
        for (var jIndex=0;jIndex < dss.staticDataModel.StateCache[iIndex].valuerange.length;jIndex++) {
            valuerange.push({  name:dss.staticDataModel.StateCache[iIndex].valuerange[jIndex].name,
                              value:dss.staticDataModel.StateCache[iIndex].valuerange[jIndex].value});
        }
        oResult.push({
            value : dss.staticDataModel.StateCache[iIndex].value,
            name : dss.staticDataModel.StateCache[iIndex].name,
            valuerange:valuerange
        });
    }
    return oResult;
}

dss.staticDataModel.getSensorDeviceArray = function() {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    return dss.staticDataModel.deviceWithSensorsCache;
}

dss.staticDataModel.getZoneArray = function() {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();

    var oResult = [];
    for ( var iIndex = 0; iIndex < dss.staticDataModel.nameCache.length; iIndex++) {
        oResult.push({
            ZoneID : dss.staticDataModel.nameCache[iIndex].ZoneID,
            name : dss.staticDataModel.nameCache[iIndex].name
        });
    }
    return oResult;
}

dss.staticDataModel.getDevicesForZone = function(zoneID, groupID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var oRetArray = [];
    for ( var i = 0; i < dss.staticDataModel.deviceCache.length; i++) {
        var oDeviceObject = dss.staticDataModel.deviceCache[i];
        var oDeviceGroup=oDeviceObject.GroupID;
        if (oDeviceGroup==8)
            oDeviceGroup=oDeviceObject.buttonActiveGroup;
        if ((oDeviceObject.ZoneID == zoneID) || (zoneID == 0))
            if ((oDeviceGroup == groupID) || (groupID == 0))
                oRetArray.push(oDeviceObject);
    }
    return oRetArray;
}
dss.staticDataModel.getNameForSensorEvent = function (device,eventid) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    if (device==null)
        return "";
    if (device.sensorEvents==null)
        return "";
    for (var iIndex=0;iIndex<device.sensorEvents.length;iIndex++) {
        if (device.sensorEvents[iIndex].id==eventid)
            return device.sensorEvents[iIndex].name;
    }
    return "";
}
dss.staticDataModel.getNameForGroup = function(zoneID, group) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var defaultName = Ext.String.format2(_("Group {group} "),{group:group});
    var baseName = "";

    switch (group) {
        case 0:
            defaultName = 'Alle Gruppen';
            baseName = 'broadcast';
        break;
        case 1:
            defaultName = _('Light');
            baseName = 'yellow'
        break;
        case 2:
            defaultName = _('Shadow');
            baseName = 'gray';
        break;
        case 3:
            defaultName = _('Climate');
            baseName = 'blue';
        break;
        case 4:
            defaultName = _('Audio');
            baseName = 'cyan';
        break;
        case 5:
            defaultName = _('Video');
            baseName = 'magenta';
        break;
        case 6:
            defaultName = _('Security');
            baseName = 'red';
        break;
        case 7:
            defaultName = _('Access');
            baseName = 'green';
        break;
        case 8:
            defaultName = _('Joker');
            baseName = 'black';
        break;
        case 9:
            defaultName = _('White');
            baseName = 'white';
        break;
        case 10:
            defaultName = _('Displays');
            baseName = 'display';
        break;
    }

    for ( var iZoneIndex = 0; iZoneIndex < dss.staticDataModel.nameCache.length; iZoneIndex++)
        if (dss.staticDataModel.nameCache[iZoneIndex].ZoneID == zoneID)
            for ( var iGroupIndex = 0; iGroupIndex < dss.staticDataModel.nameCache[iZoneIndex].groups.length; iGroupIndex++)
                if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].group == group)
                    if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].name != baseName)
                        return dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].name;
    return defaultName;
}

dss.staticDataModel.getDefaultNameForScene = function(zoneID, group, scene) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var defaultName = "Stimmung Nr. " + scene;

    switch (scene) {
        case 67:
            defaultName = _('Standby');
        break;
        case 64:
            defaultName = _('Auto Standby');
        break;
        case 68:
            defaultName = _('Deep Off');
        break;
        case 69:
            defaultName = _('Sleeping');
        break;
        case 70:
            defaultName = _('Wake up');
        break;
        case 72:
            defaultName = _('Absent');
        break;
        case 71:
            defaultName = _('Present');
        break;
        case 73:
            defaultName = _('Bell');
        break;
        case 65:
            defaultName = _('Panic');
        break;
        case 0:
            if (group == 2)
                defaultName = _('Close');
            else
                defaultName = _('Off');
        break;
        case 5:
            if (group == 2)
                defaultName = _('Open');
            else
                defaultName = _('scene 1');
        break;
        case 17:
            defaultName = _('scene 2');
        break;
        case 15:
            defaultName = _('Stop');
        break;
        case 18:
            defaultName = _('scene 3');
        break;
        case 19:
            defaultName = _('scene 4');
        break;
        case 1:
            if (group == 2)
                defaultName = _('area 1 close');
            else
                defaultName = _('area 1 off');
        break;
        case 6:
            if (group == 2)
                defaultName = _('area 1 open');
            else
                defaultName = _('area 1 on');
        break;
        case 2:
            if (group == 2)
                defaultName = _('area 2 close');
            else
                defaultName = _('area 2 off');
        break;
        case 7:
            if (group == 2)
                defaultName = _('area 2 open');
            else
                defaultName = _('area 2 on');
        break;
        case 3:
            if (group == 2)
                defaultName = _('area 3 close');
            else
                defaultName = _('area 3 off');
        break;
        case 8:
            if (group == 2)
                defaultName = _('area 3 open');
            else
                defaultName = _('area 3 on');
        break;
        case 4:
            if (group == 2)
                defaultName = _('area 4 close');
            else
                defaultName = _('area 4 off');
        break;
        case 9:
            if (group == 2)
                defaultName = _('area 4 open');
            else
                defaultName = _('area 4 on');
        break;
        case 32:
            defaultName = _('scene 10');
        break;
        case 33:
            defaultName = _('scene 11');
        break;
        case 34:
            defaultName = _('scene 20');
        break;
        case 35:
            defaultName = _('scene 21');
        break;
        case 36:
            defaultName = _('scene 30');
        break;
        case 37:
            defaultName = _('scene 31');
        break;
        case 38:
            defaultName = _('scene 40');
        break;
        case 39:
            defaultName = _('scene 41');
        break;
        case 20:
            defaultName = _('scene 12');
        break;
        case 21:
            defaultName = _('scene 13');
        break;
        case 22:
            defaultName = _('scene 14');
        break;
        case 23:
            defaultName = _('scene 22');
        break;
        case 24:
            defaultName = _('scene 23');
        break;
        case 25:
            defaultName = _('scene 24');
        break;
        case 26:
            defaultName = _('scene 32');
        break;
        case 27:
            defaultName = _('scene 33');
        break;
        case 28:
            defaultName = _('scene 34');
        break;
        case 29:
            defaultName = _('scene 42');
        break;
        case 30:
            defaultName = _('scene 43');
        break;
        case 31:
            defaultName = _('scene 44');
        break;
    }
    return defaultName;
}

dss.staticDataModel.getNameForScene = function(zoneID, group, scene) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var baseName = "";

    switch (scene) {
        case 67:
            baseName = 'STANDBY'
        break;
        case 64:
            baseName = 'AUTO_STANDBY'
        break;
        case 68:
            baseName = 'DEEP_OFF'
        break;
        case 69:
            baseName = 'SLEEPING'
        break;
        case 70:
            baseName = 'WAKE_UP'
        break;
        case 72:
            baseName = 'ABSENT'
        break;
        case 71:
            baseName = 'PRESENT'
        break;
        case 73:
            baseName = 'SIG_BELL'
        break;
        case 65:
            baseName = 'PANIC'
        break;
        case 0:
            baseName = 'T0_S0'
        break;
        case 5:
            baseName = 'T0_S1'
        break;
        case 17:
            baseName = 'T0_S2'
        break;
        case 18:
            baseName = 'T0_S3'
        break;
        case 19:
            baseName = 'T0_S4'
        break;
        case 1:
            baseName = 'T1_S0'
        break;
        case 6:
            baseName = 'T1_S1'
        break;
        case 2:
            baseName = 'T2_S0'
        break;
        case 7:
            baseName = 'T2_S1'
        break;
        case 3:
            baseName = 'T3_S0'
        break;
        case 8:
            baseName = 'T3_S1'
        break;
        case 4:
            baseName = 'T4_S0'
        break;
        case 9:
            baseName = 'T4_S1'
        break;
        case 32:
            baseName = 'T1E_S0'
        break;
        case 33:
            baseName = 'T1E_S1'
        break;
        case 34:
            baseName = 'T2E_S0'
        break;
        case 35:
            baseName = 'T2E_S1'
        break;
        case 36:
            baseName = 'T3E_S0'
        break;
        case 37:
            baseName = 'T3E_S1'
        break;
        case 38:
            baseName = 'T4E_S0'
        break;
        case 39:
            baseName = 'T4E_S1'
        break;
        case 20:
            baseName = 'T1_S2'
        break;
        case 21:
            baseName = 'T1_S3'
        break;
        case 22:
            baseName = 'T1_S4'
        break;
        case 23:
            baseName = 'T2_S2'
        break;
        case 24:
            baseName = 'T2_S3'
        break;
        case 25:
            baseName = 'T2_S4'
        break;
        case 26:
            baseName = 'T3_S2'
        break;
        case 27:
            baseName = 'T3_S3'
        break;
        case 28:
            baseName = 'T3_S4'
        break;
        case 29:
            baseName = 'T4_S2'
        break;
        case 30:
            baseName = 'T4_S3'
        break;
        case 31:
            baseName = 'T4_S4'
        break;
    }

    for ( var iZoneIndex = 0; iZoneIndex < dss.staticDataModel.nameCache.length; iZoneIndex++)
        if (dss.staticDataModel.nameCache[iZoneIndex].ZoneID == zoneID)
            for ( var iGroupIndex = 0; iGroupIndex < dss.staticDataModel.nameCache[iZoneIndex].groups.length; iGroupIndex++)
                if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].group == group)
                    for ( var iSceneIndex = 0; iSceneIndex < dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes.length; iSceneIndex++)
                        if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes[iSceneIndex].scene == scene)
                            if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes[iSceneIndex].name != null)
                                if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes[iSceneIndex].name != '')
                                    if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes[iSceneIndex].name != baseName)
                                        return dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes[iSceneIndex].name;
    return dss.staticDataModel.getDefaultNameForScene(zoneID, group, scene);
}

dss.staticDataModel.getNameForZone = function(zoneID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var baseName = Ext.String.format2(_('Room ID {zone}'), {zone:zoneID});
    if (zoneID == 0)
        baseName = _('whole installation');
    if (zoneID == -1)
        baseName = _('any room');    
    for ( var iZoneIndex = 0; iZoneIndex < dss.staticDataModel.nameCache.length; iZoneIndex++)
        if (dss.staticDataModel.nameCache[iZoneIndex].ZoneID == zoneID)
            if (dss.staticDataModel.nameCache[iZoneIndex].name != "")
                return dss.staticDataModel.nameCache[iZoneIndex].name;
    return baseName;
}

dss.staticDataModel.getGroupForZone = function(zoneID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    for ( var iZoneIndex = 0; iZoneIndex < dss.staticDataModel.nameCache.length; iZoneIndex++)
        if (dss.staticDataModel.nameCache[iZoneIndex].ZoneID == zoneID) {
            var oResult = [];
            for ( var iIndex = 0; iIndex < dss.staticDataModel.nameCache[iZoneIndex].groups.length; iIndex++)
                oResult.push({
                    'group' : dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].group,
                    'name' : dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].name,
                    'icon' : dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].icon,
                    'reachable' : dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].reachable
                });
            return oResult;
        }
    return null;
}

dss.staticDataModel.getDevice = function(deviceID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    for ( var i = 0; i < dss.staticDataModel.deviceCache.length; i++) {
        if (deviceID == dss.staticDataModel.deviceCache[i].dSID)
            return dss.staticDataModel.deviceCache[i];
    }
    return {
        dSID : deviceID,
        name : "",
        functionID : 0x1000
    };
}

dss.staticDataModel.getImagePathForScene = function(zoneID, groupID, sceneID, fUndoIcon) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    if (fUndoIcon==null)
        fUndoIcon=false;
    var fUndoPrefix="";
    if (fUndoIcon)
        fUndoPrefix='undo_';
    var baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_1"; 
    switch (groupID) {
        case 1:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_1";
        break;
        case 2:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_2";
            if (sceneID == 5)
                return baseGroupName + '_scene_5.png';
            if (sceneID == 6)
                return baseGroupName + '_scene_5.png';
            if (sceneID == 7)
                return baseGroupName + '_scene_5.png';
            if (sceneID == 8)
                return baseGroupName + '_scene_5.png';
            if (sceneID == 9)
                return baseGroupName + '_scene_5.png';
        break;
        case 3:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_3";
        break;
        case 4:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_4";
        break;
        case 5:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_5";
        break;
        case 6:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_6";
        break;
        case 7:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_7";
        break;
    }
    switch (sceneID) {
        case 0:
        case 1:
        case 2:
        case 3:
        case 4:
        case 32:
        case 34:
        case 36:
        case 38:
            return baseGroupName + '_deact.png';
        break;
        case 5:
        case 6:
        case 7:
        case 8:
        case 9:
        case 17:
        case 18:
        case 19:
        case 20:
        case 21:
        case 22:
        case 23:
        case 24:
        case 25:
        case 26:
        case 27:
        case 28:
        case 29:
        case 30:
        case 31:
        case 33:
        case 35:
        case 37:
        case 39:
            return baseGroupName + '_active.png';
        break;
        case 15:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_stop.png';
        break;
        case 64:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_standby.png';
        break;
        case 65:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_panic.png';
        break;
        case 67:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_standby.png';
        break;
        case 68:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_deep_off.png';
        break;
        case 69:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_sleeping.png';
        break;
        case 70:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_wakeup.png';
        break;
        case 71:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_present.png';
        break;
        case 72:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_absent.png';
        break;
        case 73:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_bell.png';
        break;
    }
}

dss.staticDataModel.getScene = function(zoneId, groupId,sceneID) {
    var oSceneArray=dss.staticDataModel.getScenes(zoneId, groupId);
    for (var iIndex=0;iIndex<oSceneArray.length;iIndex++) {
        if (oSceneArray[iIndex].id==sceneID)
            return oSceneArray[iIndex]; 
    }
    return null;
}

dss.staticDataModel.getScenes = function(zoneId, groupId) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var oDeviceArray = dss.staticDataModel.getDevicesForZone(zoneId, groupId);

    var oRetArray = [];
    var sceneArray = [ 0, 5, 17, 18, 19, 1, 6, 2, 7, 3, 8, 4, 9, 32, 33, 20, 21, 22, 34, 35, 23, 24, 25, 36, 37, 26, 27, 28, 38, 39, 29, 30, 31, 67,
            64, 68, 69, 70, 72, 71, 73, 65 ];

    if (groupId == 2)
    {
        sceneArray.splice(33,0,15);
    }

    for ( var iIndex = 0; iIndex < sceneArray.length; iIndex++) {
        var oSzeneObject = {
            id : sceneArray[iIndex],
            groupID : groupId,
            zoneID : zoneId,
            reachable : false,
            undoable:false,
        };
        oSzeneObject.name = dss.staticDataModel.getNameForScene(oSzeneObject.zoneID, oSzeneObject.groupID, oSzeneObject.id);
        oSzeneObject.defaultName = dss.staticDataModel.getDefaultNameForScene(oSzeneObject.zoneID, oSzeneObject.groupID, oSzeneObject.id);
        oSzeneObject.icon = dss.staticDataModel.getImagePathForScene(oSzeneObject.zoneID, oSzeneObject.groupID, oSzeneObject.id);
        oRetArray.push(oSzeneObject);
    }

    
    function searchAndEnableScene(id) {
        for ( var iIndex = 0; iIndex < oRetArray.length; iIndex++)
            if (oRetArray[iIndex].id == id)
                oRetArray[iIndex].reachable = true;
    }
    
    function searchAndSetUndo(id,undo) {
        for ( var iIndex = 0; iIndex < oRetArray.length; iIndex++)
            if (oRetArray[iIndex].id == id)
                oRetArray[iIndex].undoable = undo;
    }
    
    if (groupId != 0)
        for ( var iDeviceIndex = 0; iDeviceIndex < oDeviceArray.length; iDeviceIndex++) {
            var oDev = oDeviceArray[iDeviceIndex];
            
            if (oDev.tasterMode>0)
                if (groupId == 2)
                {
                    searchAndEnableScene(15);
                }
            
            switch (oDev.tasterMode) {
                case 0:
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                    searchAndEnableScene(5);
                    searchAndEnableScene(0);
                break;
                case 1:
                    searchAndEnableScene(1);
                    searchAndEnableScene(6);
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                break;
                case 2:
                    searchAndEnableScene(2);
                    searchAndEnableScene(7);
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                break;
                case 3:
                    searchAndEnableScene(3);
                    searchAndEnableScene(8);
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                break;
                case 4:
                    searchAndEnableScene(4);
                    searchAndEnableScene(9);
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                break;
                case 5:
                    searchAndEnableScene(0);
                    searchAndEnableScene(5);
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                break;
                case 6:
                    searchAndEnableScene(32);
                    searchAndEnableScene(33);
                    searchAndEnableScene(20);
                    searchAndEnableScene(21);
                    searchAndEnableScene(22);
                break;
                case 7:
                    searchAndEnableScene(34);
                    searchAndEnableScene(35);
                    searchAndEnableScene(23);
                    searchAndEnableScene(24);
                    searchAndEnableScene(25);
                break;
                case 8:
                    searchAndEnableScene(36);
                    searchAndEnableScene(37);
                    searchAndEnableScene(26);
                    searchAndEnableScene(27);
                    searchAndEnableScene(28);
                break;
                case 9:
                    searchAndEnableScene(38);
                    searchAndEnableScene(39);
                    searchAndEnableScene(29);
                    searchAndEnableScene(30);
                    searchAndEnableScene(31);
                break;
                case 10:
                    searchAndEnableScene(1);
                    searchAndEnableScene(6);
                    searchAndEnableScene(20);
                    searchAndEnableScene(21);
                    searchAndEnableScene(22);
                break;
                case 11:
                    searchAndEnableScene(2);
                    searchAndEnableScene(7);
                    searchAndEnableScene(23);
                    searchAndEnableScene(24);
                    searchAndEnableScene(25);
                break;
                case 12:
                    searchAndEnableScene(3);
                    searchAndEnableScene(8);
                    searchAndEnableScene(26);
                    searchAndEnableScene(27);
                    searchAndEnableScene(28);
                break;
                case 13:
                    searchAndEnableScene(4);
                    searchAndEnableScene(9);
                    searchAndEnableScene(29);
                    searchAndEnableScene(30);
                    searchAndEnableScene(31);
                break;
            }
        }

    if ((zoneId != 0) && (groupId == 0)) {
        searchAndEnableScene(67);
        searchAndEnableScene(68);
        searchAndEnableScene(69);
        searchAndEnableScene(70);
    }

    if ((zoneId == 0) && (groupId == 0))
        for ( var i = 0; i < dss.staticDataModel.deviceCache.length; i++) {
            var oDeviceObject = dss.staticDataModel.deviceCache[i];
            if (oDeviceObject.functionID == 0x7010)
                searchAndEnableScene(73); // klingel
            if (oDeviceObject.functionID == 0x6001) {
                searchAndEnableScene(65); // panik
            }
            if (oDeviceObject.functionID == 0x7050) {
                searchAndEnableScene(71); // kommen
                searchAndEnableScene(72); // gehen
            }
        }

    searchAndSetUndo(65,true);
    return oRetArray;
}

dss.staticDataModel.getImagePathForGroup = function(zoneID, groupID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    switch (groupID) {
        case 0:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_0.png';
        break;
        case 1:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_1.png';
        break;
        case 2:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_2.png';
        break;
        case 3:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_3.png';
        break;
        case 4:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_4.png';
        break;
        case 5:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_5.png';
        break;
        case 6:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_6.png';
        break;
        case 7:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_7.png';
        break;
        case 8:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_8.png';
        break;
        case 9:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_9.png';
        break;
        case 10:
            return dss.staticDataModel.baseImagePath + 't.gif';
        break;
    }
}

dss.staticDataModel.getImageForScene = function(zoneID, groupID, sceneID,fUndoIcon) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
            
    return '<img src="' + dss.staticDataModel.getImagePathForScene(zoneID, groupID, sceneID,fUndoIcon) + '" alt="'
            + dss.staticDataModel.getNameForScene(zoneID, groupID, sceneID) + '">';
}

dss.staticDataModel.getImageForGroup = function(zoneID, groupID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    return '<img src="' + dss.staticDataModel.getImagePathForGroup(zoneID, groupID) + '" alt="'
            + dss.staticDataModel.getNameForGroup(zoneID, groupID) + '">';

}

dss.staticDataModel.getImageForDevice = function(device) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var sIcon = "default/star_white";
    var fBlackPossible = false;
    var fBlackBlackPossible = false;
    switch ((device.productID >> 10) & 0x3f) {
        case 0:
            sIcon = "km/";
            fBlackPossible = true;
            fBlackBlackPossible = true;
        break;
        case 1:
            sIcon = "tkm/";
            fBlackPossible = true;
            fBlackBlackPossible = true;
        break;
        case 2:
            sIcon = "sdm/";
            fBlackPossible = true;
        break;
        case 3:
            sIcon = "kl/";
            fBlackPossible = true;
            fBlackBlackPossible = true;
        break;
        case 4:
            sIcon = "tkm/";
            fBlackPossible = true;
        break;
        case 5:
            sIcon = "zws/";
            fBlackPossible = true;
            fBlackBlackPossible = true;
        break;
        case 6:
            sIcon = "sds/";
            fBlackPossible = true;
        break;

    }

    switch ((device.functionID & 0xf000) >> 12) {
        case 1:
            sIcon += "yellow";
        break;
        case 2:
            sIcon += "grey";
        break;
        case 3:
            sIcon += "blue";
        break;
        case 4:
            sIcon += "cyan";
        break;
        case 5:
            sIcon += "magenta";
        break;
        case 6:
            sIcon += "red";
        break;
        case 7:
            sIcon += "green";
        break;
        case 8:
            sIcon += "black";
            if (fBlackPossible) {
                if (device.buttonActiveGroup == 1)
                    sIcon += "_yellow";
                if (device.buttonActiveGroup == 2)
                    sIcon += "_grey";
                if (device.buttonActiveGroup == 3)
                    sIcon += "_blue";
                if (device.buttonActiveGroup == 4)
                    sIcon += "_cyan";
                if (device.buttonActiveGroup == 5)
                    sIcon += "_magenta";
                if (device.buttonActiveGroup == 6)
                    sIcon += "_red";
                if (device.buttonActiveGroup == 7)
                    sIcon += "_green";
                if (fBlackBlackPossible)
                    if (device.buttonActiveGroup == 8)
                        sIcon += "_black";
            }
        break;
        default:
            sIcon = "default/star_white";
        break;
    }
    return dss.staticDataModel.baseImagePath + "deviceIcons/" + sIcon + ".png"
}

dss.staticDataModel.getProductNameForDevice = function(device) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var sName = "";

    switch ((device.functionID & 0xf000) >> 12) {
        case 1:
            sName += "GE";
        break;
        case 2:
            sName += "GR";
        break;
        case 3:
            sName += "BL";
        break;
        case 4:
            sName += "TK";
        break;
        case 5:
            sName += "MG";
        break;
        case 6:
            sName += "RT";
        break;
        case 7:
            sName += "GN";
        break;
        case 8:
            sName += "SW";
        break;
        case 9:
            sName += "WE";
        break;
    }
    sName+='-';
    switch ((device.productID >> 10) & 0x3f) {
        case 0:
            sName+='KM'
        break;
        case 1:
            sName+='TKM'
        break;
        case 2:
            sName+='SDM'
        break;
        case 3:
            sName+='KL'
        break;
        case 4:
            sName+='TUP'
        break;
        case 5:
            sName+='ZWS'
        break;
        case 6:
            sName+='SDS'
        break;

    }

    return sName + ' ' + (device.productID & 0x3ff);
}

/*
 * oJsonObject: Typical dss-Answer Object paramDef: array of expected Objects in
 * AnswerArray { name: properyName, type:
 * simple|action|trigger|condition/enabled }
 */
dss.parsePropertyQueryAnswer = function(oJsonObject, paramDef) {
    if (oJsonObject.ok == null)
        return null;
    if (!oJsonObject.ok)
        return null;
    if (oJsonObject.result == null)
        return null;
    var oReturnArray = [];
    for ( var sKey in oJsonObject.result) {
        var oRootArray = oJsonObject.result[sKey];
        for ( var iIndex = 0; iIndex < oRootArray.length; iIndex++) {
            var oObject = {};
            var oIteratorObject = oRootArray[iIndex];
            for ( var sIndex = 0; sIndex < paramDef.length; sIndex++) {
                var oKeyParameter = paramDef[sIndex].name;

                if (paramDef[sIndex].type == 'simple') {
                    if (oIteratorObject[oKeyParameter] != null)
                        oObject[oKeyParameter] = escape(oIteratorObject[oKeyParameter]);
                    else
                        oObject[oKeyParameter] = null;
                } else if (paramDef[sIndex].type == 'date') {
                    if (oIteratorObject[oKeyParameter] != null)
                        oObject[oKeyParameter] = new Date(parseInt(oIteratorObject[oKeyParameter],10)*1000);
                    else
                        oObject[oKeyParameter] = null;
                } else if ((paramDef[sIndex].type == 'action') || (paramDef[sIndex].type == 'trigger')) {
                    oObject[oKeyParameter] = [];
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject[oKeyParameter] != null) {

                                    for ( var kIndex = 0; kIndex < oArrayObject[oKeyParameter].length; kIndex++) {
                                        var resultObject = oArrayObject[oKeyParameter][kIndex];
                                        var oActionObject = {};
                                        for ( var oKey in resultObject) {
                                            oActionObject[oKey] = resultObject[oKey];
                                        }
                                        oObject[oKeyParameter].push(oActionObject);
                                    }

                                }
                            }
                        }
                    }
                } else if ((paramDef[sIndex].type == 'condition')) {
                	var oConditionObject={
                	        enabled: null, // singular value
                	        weekdays: null, // singularvalue
                	        timeframe: null, // array ....
                	        zoneState:null,
                	        systemState:null
                	};
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject[oKeyParameter] != null) {
                                	if (oArrayObject['enabled']!=null) {
                                		oConditionObject.enabled=oArrayObject['enabled'];
                                	}
                                	if ((oArrayObject['time-start']!=null) && (oArrayObject['time-end']!=null)) {
                                		var startArray=oArrayObject['time-start'].split(':');
                                		var iStart=parseInt(startArray[0],10)*3600 + parseInt(startArray[1],10)*60 + parseInt(startArray[2],10); 
                                		var endArray=oArrayObject['time-end'].split(':');
                                		var iEnd=parseInt(endArray[0],10)*3600 + parseInt(endArray[1],10)*60 + parseInt(endArray[2],10); 
                                		oConditionObject.timeframe=[{start: {timeBase:'daily',offset:iStart},
                                			                         end: {timeBase:'daily',offset:iEnd} }];
                                    }
                                	if (oArrayObject['weekdays']!=null) {
                                		var weekArray=oArrayObject['weekdays'].split(',');
                                		oConditionObject.weekdays=[];
                                		for (var wIndex=0;wIndex<weekArray.length;wIndex++) {
                                			switch (weekArray[wIndex]) {
	                                			case '0':
		                            				oConditionObject.weekdays.push('SU');
		                            			break;
	                                			case '1':
		                            				oConditionObject.weekdays.push('MO');
		                            			break;
	                                			case '2':
		                            				oConditionObject.weekdays.push('TU');
		                            			break;
	                                			case '3':
		                            				oConditionObject.weekdays.push('WE');
		                            			break;
	                                			case '4':
		                            				oConditionObject.weekdays.push('TH');
		                            			break;
	                                			case '5':
		                            				oConditionObject.weekdays.push('FR');
		                            			break;
	                                			case '6':
		                            				oConditionObject.weekdays.push('SA');
		                            			break;
                                			}
                                		}
                                	}
                                    for ( var kIndex = 0; kIndex < oArrayObject[oKeyParameter].length; kIndex++) {
                                        var resultObject = oArrayObject[oKeyParameter][kIndex];
                                        if (resultObject.states!=null) {
                                        	oConditionObject.systemState=[];
                                        	for (var sKey in resultObject) {
                                        		if (sKey!='states') {
                                        			oConditionObject.systemState.push({name:sKey,value:resultObject[sKey]});
                                        		}
                                        	}
                                        }
                                        if (resultObject['zone-states']!=null) {
                                        	oConditionObject.zoneState=[];
                                        	for (var zIndex=0;zIndex<resultObject['zone-states'].length;zIndex++) {
                                        		oConditionObject.zoneState.push({zone:resultObject['zone-states'][zIndex].zone,group:resultObject['zone-states'][zIndex].group,scene:resultObject['zone-states'][zIndex].scene})	
                                        	}
                                        }
                                    }

                                }
                            }
                        }
                    }    
                    oObject[oKeyParameter]=oConditionObject;

                } else if ((paramDef[sIndex].type == 'condition/enabled')) {
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject.conditions != null)
                                    if (oArrayObject.enabled != null)
                                        oObject[oKeyParameter] = !oArrayObject.enabled;
                            }
                        }
                    }
                } else if ((paramDef[sIndex].type == 'condition/state')) {
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject.conditions != null) {
                                    for (var kIndex=0 ; kIndex<oArrayObject.conditions.length; kIndex++) {
                                        if (oArrayObject.conditions[kIndex]!=null) {
                                            if (oArrayObject.conditions[kIndex][paramDef[sIndex].name]!=null)
                                                oObject[oKeyParameter] = oArrayObject.conditions[kIndex][paramDef[sIndex].name];
                                        }
                                    }
                                }
                            }
                        }
                    }
                } else if ((paramDef[sIndex].type == 'message')) {
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject.message != null) {
                                    oObject[oKeyParameter] = {};
                                    oObject[oKeyParameter].messageType = oArrayObject.messageType;
                                    oObject[oKeyParameter].receiver = oArrayObject.receiver;
                                    oObject[oKeyParameter].subject = escape(oArrayObject.subject);
                                    oObject[oKeyParameter].message = escape(oArrayObject.messageBody);
                                }
                            }
                        }
                    }
                } else if ((paramDef[sIndex].type == 'recurrence')) {
                    var oTimeObject = {};
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject.recurrenceBase != null)
                                    oTimeObject.recurrenceBase = oArrayObject.recurrenceBase;
                                if (oArrayObject.time != null) {
                                    oTimeObject.timeArray = [];
                                    for ( var oKey in oArrayObject.time) {
                                        var oSubArray = oArrayObject.time[oKey]
                                        for ( var aKey in oSubArray) {
                                            if (oSubArray[aKey] != null)
                                                oTimeObject.timeArray.push(oSubArray[aKey]);
                                        }
                                    }
                                }
                            }
                        }
                    }
                    oObject[oKeyParameter] = oTimeObject;
                } else if ((paramDef[sIndex].type == 'time')) {
                    var oTimeObject = {};
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject.timeBase != null)
                                    oTimeObject.timeBase = oArrayObject.timeBase;
                                if (oArrayObject.offset != null)
                                    oTimeObject.offset = oArrayObject.offset;
                                if (oArrayObject.limitBefore != null)
                                    oTimeObject.limitBefore = oArrayObject.limitBefore;
                                if (oArrayObject.limitAfter != null)
                                    oTimeObject.limitAfter = oArrayObject.limitAfter;
                                if (oArrayObject.random != null)
                                    oTimeObject.random = oArrayObject.random;
                            }
                        }
                    }
                    oObject[oKeyParameter] = oTimeObject;
                }
            }
            oReturnArray.push(oObject);
        }

    }
    return oReturnArray;
}

dss.validateActionObject = function (oActionObject) {
    var fValue=true;
    switch (oActionObject.type) {
        case 'zone-value': {
            return false; // nicht mehr unterstuetzt
            break;
        } 
        case 'zone-scene': {
            if (oActionObject.zone==0) {
                // Apartment
                if (oActionObject.group!=0) {
                    if (oActionObject.scene>63)
                        return false; // apartment-szenen und raumszenen sind
										// immer falsch
                    var oGroups=dss.staticDataModel.getGroupForZone(oActionObject.zone);
                    for (var iIndex=0;iIndex<oGroups.length;iIndex++) {
                        if (oGroups[iIndex].group==oActionObject.group)
                            return oGroups[iIndex].reachable; // nur wenn
																// gruppe
																// erreichbar
																// ist, dann
																// kann aktion
																// laufen
                    }
                    return false; // gruppe ist nicht in der liste mit drin
                } else {
                    if (oActionObject.scene>63)
                        return true; // Alle Rume + Deepoff ist auswaehlbar,
										// daher hier genehmigt
                    else
                        return false;
                }
            } else {
                // Zone
                var oZones=dss.staticDataModel.getZoneArray();
                var fValue=false;
                for (var iIndex=0;iIndex<oZones.length;iIndex++) {
                    if (oZones[iIndex].ZoneID==oActionObject.zone)
                        fValue=true;
                }
                if (fValue==false)
                    return false; // zone is not valid
                if (oActionObject.group==0) {
                    if (oActionObject.scene==64)
                        return true;
                    if (oActionObject.scene==67)
                        return true;
                    if (oActionObject.scene==68)
                        return true;
                    if (oActionObject.scene==69)
                        return true;
                    if (oActionObject.scene==70)
                        return true;
                    return false;
                } else {
                    if (oActionObject.scene>63)
                        return false; // apartment-szenen und raumszenen sind
										// immer falsch
                    var oGroups=dss.staticDataModel.getGroupForZone(oActionObject.zone);
                    for (var iIndex=0;iIndex<oGroups.length;iIndex++) {
                        if (oGroups[iIndex].group==oActionObject.group)
                            return oGroups[iIndex].reachable; // nur wenn
																// gruppe
																// erreichbar
																// ist, dann
																// kann aktion
																// laufen
                    }
                    return false; // gruppe ist nicht in der liste mit drin
                }
            }
            
            break;
        }
        case 'undo-zone-scene': {
            var oSceneObject=dss.staticDataModel.getScene(oActionObject.zone,oActionObject.group,oActionObject.scene);
            if (oSceneObject==null)
                return false;
            if (oSceneObject.undoable==null)
                return false;
            return oSceneObject.undoable;            
        }
        case 'device-scene': { // device ohne ausgang!
            var oDevice = dss.staticDataModel.getDevice(oActionObject.dsid);
            if (!oDevice.present) {
                return false;  // nicht vorhandene Geraete -> Fehler
            }
            if (oDevice.outputMode==0) {
                return false;
            }
            if (oActionObject.scene>63) {
                return false;
            }
            return true;
            break;
        }
        case 'device-value': {
            return false; // nicht mehr unterstuetzt
            break;
        }
        case 'device-blink': {
            var oDevice = dss.staticDataModel.getDevice(oActionObject.dsid);
            if (!oDevice.present) {
                return false;  // nicht vorhandene Geraete -> Fehler
            }
            if (oDevice.outputMode==0) {
                return false;
            }
            return true;
            break;
        }
        case 'zone-blink': {
            if (oActionObject.zone==0) {
                if (oActionObject.group==1) { // nur licht darf blinken
                    return true;
                } else {
                    return false;
                }
            }
            var oZones=dss.staticDataModel.getZoneArray();
            var fValue=false;
            for (var iIndex=0;iIndex<oZones.length;iIndex++) {
                if (oZones[iIndex].ZoneID==oActionObject.zone)
                    fValue=true;
            }
            if (fValue==false)
                return false;
            if (oActionObject.group!=1) // nur licht darf blinken
                return false;
            var oGroups=dss.staticDataModel.getGroupForZone(oActionObject.zone);
            for (var iIndex=0;iIndex<oGroups.length;iIndex++) {
                if (oGroups[iIndex].group==oActionObject.group)
                    return oGroups[iIndex].reachable; // falls licht da ist,
														// dann blinkt es nur
														// dann, wenn es
														// reachable ist
            }
            return false;
            break;
        }
        case 'custom-event': {
            for (var iIndex=0;iIndex<dss.staticDataModel.getHLE().length;iIndex++) {
                if (""+ dss.staticDataModel.getHLE()[iIndex].id==oActionObject.event) {
                    return true;
                }
            }
            return false;
            break;
        }
        case 'url' : {
            return true;
            break;
        }
        default: 
            return false;
        break;
    }
    return false;
}

/*
 * als default wird framework/locale/{languageSuffix}/dss-addon-framework.po
 * geladen es knnen aber auch weitere urls angegeben werden, wobei
 * {languageSuffix} durch den zweiten parameter ersetzt wird oLangdefinition
 * mssen ['url'] sein
 */
dss.buildUpLang=function(oLangDefinitions,languageSuffix) {
    /*
	 * _ = function (s) { if (dss.translation[s]==null) return s; return
	 * dss.translation[s]; }
	 */
    
    var params = {  
            domain : "dss-addon-framework",
            locale_data : {}
    };
    
    if (languageSuffix==null) {
        var oLang=JSON.parse(dss.ajaxSyncRequest('/json/property/query',{query:'/system/language(locale)'}));
        if (oLang!=null)
            if (oLang.ok)
                languageSuffix=oLang.result.language[0].locale; 
    }
    if (languageSuffix==null)
        languageSuffix='de_DE';
    dss.staticDataModel.activeLanguage=languageSuffix;
    if (oLangDefinitions==null)
        oLangDefinitions=[];
    
    oLangDefinitions.splice(0,0,'/framework/locale/{languageSuffix}/dss-addon-framework.po');
    locale_ = {};
    for (var lIndex=0;lIndex<oLangDefinitions.length;lIndex++) {
        var sDomain=params.domain;
        
        var sURL=Ext.String.format2(oLangDefinitions[lIndex],{'languageSuffix':languageSuffix},false);
        
        if (params.locale_data[sDomain]==null)
            params.locale_data[sDomain]={};
        
        var sString=dss.ajaxSyncRequest(sURL,{});
        
        var oArray=sString.split('\n');
        var iState=0;
        var sMSGID=null;
        for (var iIndex=0;iIndex<oArray.length;iIndex++)
        {
            if (oArray[iIndex][0]=='#') {
                
            } else if (oArray[iIndex].indexOf("msgid")>-1) {
                iState=1;
                msgid=oArray[iIndex].substr(oArray[iIndex].indexOf('"')+1);
                msgid=msgid.substr(0,msgid.lastIndexOf('"'));
            } else if (oArray[iIndex].indexOf("msgstr")>-1) {
                if (iState==1) {
                    iState=2;
                    msgstr=oArray[iIndex].substr(oArray[iIndex].indexOf('"')+1);
                    msgstr=msgstr.substr(0,msgstr.lastIndexOf('"'));
                    params.locale_data[sDomain][msgid]=[null,msgstr];                    
                }
            }
        }
    }

    dss.staticDataModel.gt = new Gettext(params);

    Ext.Date.dayNames = [ _('sunday'), _('monday'), _('tuesday'), _('wednesday'), _('thursday'), _('friday'), _('saturday') ];
    Ext.Date.MonthNames = [ _('january'), _('february'), _('march'), _('april'), _('may'), _('june'), _('july'), _('august'), _('september'), _('october'), _('november'), _('december') ];


    
}

/**
 * Gettext translation method
 * 
 * @param {String}
 *            msgid The string to translate
 * @param {String}
 *            arg1 Typically the plural form
 * @param {int}
 *            arg1 Typically the count
 * @return {String} The translated string if available, otherwise return msgid
 */
function _(msgid, arg1, arg2) {
    if (dss.staticDataModel.gt) {
        if (arguments.length === 1) {
            return dss.staticDataModel.gt.gettext(msgid);
        } else if (arguments.length === 2) {
            return dss.staticDataModel.gt.ngettext(msgid, arg1);
        } else if (arguments.length === 3) {
            return dss.staticDataModel.gt.ngettext(msgid, arg1, arg2);
        }
    }
    return msgid;
}

